//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "uplot3d.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Colsel"
#pragma link "NumLab"
#pragma link "plot3d"
#pragma resource "*.dfm"
TForm1 *Form1;

const int XRes = 50;
const int YRes = 30;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Plot3D1MouseAction(TObject *Sender, int &CenterX,
      int &CenterY, double &RotXAngle, double &RotZAngle,
      double &Magnification, TShiftState Shift)
{
NLabX->Value = RotXAngle;
NLabZ->Value = RotZAngle;
NLabMag->Value = Magnification;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)

{
int i;
int j;

Plot3D1->GridMat->Resize (XRes,YRes);
for (i=1; i<=XRes; i++)
  {
  for (j=1; j<=YRes; j++)
    {
    Plot3D1->GridMat->Elem[i][j] = sin(i*0.5)*cos(0.15*j)+0.01*(i-(XRes / 2))*(j-(YRes / 2)) +
                                  13*exp(-0.04*((i-(XRes / 2))*(i-(XRes / 2))+(j-(YRes / 2))*(j-(YRes / 2))))+
                                  10*exp(-0.02*((i-(XRes / 3))*(i-(XRes / 3))+(j-3*(YRes / 5))*(j-3*(YRes / 5))))-1;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BButExitClick(TObject *Sender)
{
Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarAngleXChange(TObject *Sender)
{
Plot3D1->ViewAngleX = ScrBarAngleX->Position;
NLabX->Value = ScrBarAngleX->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarAngleZChange(TObject *Sender)
{
Plot3D1->ViewAngleZ = ScrBarAngleZ->Position;
NLabZ->Value = ScrBarAngleZ->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarMagnifChange(TObject *Sender)
{
Plot3D1->Magnification = 0.01*ScrBarMagnif->Position;
NLabMag->Value = 0.01*ScrBarMagnif->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CSelHighChange(TObject *Sender)
{
Plot3D1->ColorHigh = CSelHigh->SelColor;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CselMidChange(TObject *Sender)
{
Plot3D1->ColorMid = CselMid->SelColor;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CSelLowChange(TObject *Sender)
{
Plot3D1->ColorLow = CSelLow->SelColor;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CSelGridChange(TObject *Sender)
{
Plot3D1->ColorMesh = CSelGrid->SelColor;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CBoxMeshClick(TObject *Sender)
{
Plot3D1->MeshVisible = CBoxMesh->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotate1Click(TObject *Sender)
{
Plot3D1->MouseAction = maRotate;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pan1Click(TObject *Sender)
{
Plot3D1->MouseAction = maPan;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Zoom1Click(TObject *Sender)
{
Plot3D1->MouseAction = maZoom;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RotateandZoom1Click(TObject *Sender)
{
Plot3D1->MouseAction = maRotAndZoom;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RotXOnly1Click(TObject *Sender)
{
Plot3D1->MouseAction = maRotXOnly;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RotZOnly1Click(TObject *Sender)
{
Plot3D1->MouseAction = maRotZOnly;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CBox3colmodClick(TObject *Sender)
{
if (CBox3colmod->Checked)
  {
  Plot3D1->ColorCodingMode = ccmThreeColors;
  LblColMid->Enabled = true;
  CselMid->Color = clWhite;
  CselMid->Enabled = true;
  }
  else
  {
  Plot3D1->ColorCodingMode = ccmTwoColors;
  LblColMid->Enabled = false;
  CselMid->Color = clBtnFace;
  CselMid->Enabled = false;
  };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SbAutoscaleClick(TObject *Sender)
{
Plot3D1->AutoScale();
ScrBarSclX->Position = ceil(Plot3D1->ScaleFactX*100);
ScrBarSclY->Position = ceil(Plot3D1->ScaleFactY*100);
ScrBarSclZ->Position = ceil(Plot3D1->ScaleFactZ*100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarSclXChange(TObject *Sender)
{
Plot3D1->ScaleFactX = 0.01*ScrBarSclX->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarSclYChange(TObject *Sender)
{
Plot3D1->ScaleFactY = 0.01*ScrBarSclY->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarSclZChange(TObject *Sender)
{
Plot3D1->ScaleFactZ = 0.01*ScrBarSclZ->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBResetClick(TObject *Sender)
{
Plot3D1->Reset();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrBarColorHighChange(TObject *Sender)
{
Plot3D1->ColorScaleHigh = 0.1*ScrBarColorHigh->Position;
}
//---------------------------------------------------------------------------

